/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.plugins.sql

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 5/6/11
 * Time: 2:43 PM
 * To change this template use File | Settings | File Templates.
 */
class SqlLocator {

    def sqlProviders = [mysql: new metridoc.plugins.sql.MySql(), h2: new metridoc.plugins.sql.H2()]
    def urlToProvider = [:]
    def static SqlLocator instance

    def static SqlLocator getInstance() {
        if(instance == null) {
            instance = new SqlLocator()
        }

        return instance
    }

    def static getProvider(String url) {
        def locator = getInstance()

        if (!locator.urlToProvider.containsKey(url)) {
            def result
            locator.sqlProviders.keySet().each {key ->
                if(url.contains(key)) {
                    result = locator.sqlProviders[key]
                }
            }
            locator.urlToProvider[url] = result
        }

        if(!locator.urlToProvider[url]) {
            throw new metridoc.plugins.sql.NoSqlProviderException(url)
        }

        return locator.urlToProvider[url]
    }
}
